<?php

namespace Ems\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

use Util\DateUtil;

class ApuracaoAdcNoturnoRepository {
    /** @var EntityManager */
    protected $entityManager;

    /** @var Connection */
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ) {
        $this->entityManager        = $entityManager;
        $this->connection           = $entityManager->getConnection();
    }

    public function getQtdAdcNoturno($diaInicio, $diaFim, $nrvinculom, $nrorg)
    {   
        $sql = "
        SELECT 
        SUM(ROUND(QTREFAPURSITUFREQ,5)) AS QTDE_HORAS, 
        NRVINCULOM
       FROM PTO_RESUMOSITUFREQ RE
      WHERE RE.NRORG = :P_NRORG
        AND RE.DTAPURACAOSITUFREQ BETWEEN :P_DIAINICIO AND :P_DIAFIM
        AND RE.NRVINCULOM = :P_NRVINCULOM
        AND RE.NRSITUFREQUENCIA IN (SELECT SF.NRSITUFREQUENCIA
                                   FROM FOLHA.PTO_ASSOCSITUFREQ SF
                                  WHERE SF.NRORG = :P_NRORG
                                    AND SF.NRCALCULOSITUFREQ = 9000
                                  UNION
                                 SELECT 9000
                                   FROM DUAL)
      GROUP BY NRVINCULOM";
        
        $params = array('P_NRORG' => $nrorg, 'P_NRVINCULOM' => $nrvinculom, 'P_DIAINICIO' => $diaInicio, 'P_DIAFIM' => $diaFim);
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        
        return $query->fetchAll();
    }
    
}