<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class CalculoFolhaPercRepository {
    
    protected  $connection;
    
    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function getSumEventos($params) {
        $p_nrocor = is_null($params['P_NROCOR']) ? 'NULL' : trim($params['P_NROCOR']);

$sql = <<<SQL
        SELECT SUM(VREVENTOFOLHA) VREVENTOFOLHA, NREVENTOM
          FROM FPA_ITECALCFOLHA
         WHERE NRORG = :P_NRORG
           AND NREVENTOM = :P_NREVENTOM
           AND NRVINCULOM = :P_NRVINCULOM
           AND EXISTS (SELECT 1 
                         FROM FPA_CALCULOFOLHA
                        WHERE NRORG = :P_NRORG
                          AND NRCALCULOFOLHA = FPA_ITECALCFOLHA.NRCALCULOFOLHA
                          AND NRTIPOMOVIMENT = :P_NRTIPOMOVIMENT
                          AND (NROCORRECAL IN ($p_nrocor) OR :P_NROCOR IS NULL)
                          AND NRTPMODALIDCAL = :P_NRTPMODALIDCAL
                          AND DTOCORRENCIA BETWEEN :P_INI AND :P_FIN)
        GROUP BY NREVENTOM
SQL;
      $result = $this->entityManager->getConnection()->prepare($sql);
      $result->execute($params);

      return $result->fetch();
  }

}