CREATE OR REPLACE PROCEDURE RELEITURA_DDA
AS
  V_ERRO          BOOLEAN;
  V_TITULO        BOOLEAN;
  V_IDCONSISTEVLR VARCHAR2(1);
  V_IDCONSISTE    VARCHAR2(1);
  V_NRNOTAFISC    VARCHAR2(20);
  V_TNRNOTAFISC   VARCHAR2(1);
  V_CDFORNECED    VARCHAR2(21);
  V_TCDFORNECED   VARCHAR2(1);
  V_NRINSJUREMPR  VARCHAR2(20);
  V_DTVENBOLPAG   DATE;
  V_TDTVENBOLPAG  VARCHAR2(1);
  V_IDSTATUSA     VARCHAR2(1);
  V_IDSTATUSB     VARCHAR2(1);
  V_IDSTATUSC     VARCHAR2(1);
  V_VRFINALBPAG FLOAT;
  V_TODOSVR           VARCHAR2(1);
  V_CDFILIAL          VARCHAR2(4);
  V_NRLANBOLPAG       VARCHAR2(10);
  V_CDREDUCONT        VARCHAR2(3);
  V_CDTPBAIXAPAG      VARCHAR2(2);
  V_REC_CDFILIAL      VARCHAR2(4);
  V_REC_NRLANBOLPAG   VARCHAR2(10);
  V_REC_CDBARRAPAG    VARCHAR2(44);
  V_REC_COUNT_TITULOS NUMBER;
  CURSOR C_DADOS_DDA( V_NRNOTAFISC VARCHAR2, V_TNRNOTAFISC VARCHAR2, V_CDFORNECED VARCHAR2, V_TCDFORNECED VARCHAR2, V_NRINSJUREMPR VARCHAR2, V_DTVENBOLPAG DATE, V_TDTVENBOLPAG VARCHAR2, V_IDSTATUSA VARCHAR2, V_IDSTATUSB VARCHAR2, V_IDSTATUSC VARCHAR2, V_VRFINALBPAG FLOAT, V_TODOSVR VARCHAR2 )
  IS
    SELECT BP.CDFILIAL,
           BP.NRLANBOLPAG,
           BP.CDBARRAPAG,
           COUNT(*) OVER (PARTITION BY BP.CDFORNECED, BP.DTVENBOLPAG, BP.VRFINALBPAG, BP.IDSTATBPAG) AS COUNT_TITULOS
      FROM BOLETPAGAR BP
     INNER JOIN CONTAPAGAR CP
        ON CP.CDFILIBPAG   = BP.CDFILIAL
       AND CP.NRLANBOLPAG = BP.NRLANBOLPAG
     INNER JOIN NOTAFISCAL NF
        ON NF.CDFILIAL    = CP.CDFILIAL
       AND NF.NRLANCTONF = CP.NRLANCTONF
       AND ((LPAD(NF.NRNOTAFISC||NF.CDSERIEENTR, 20, 0)     = NVL(V_NRNOTAFISC, 'XXXXXXXXXXXXXXXXXXXX'))
        OR (LPAD(NF.NRNOTAFISC, 20, 0) = NVL(V_NRNOTAFISC, 'XXXXXXXXXXXXXXXXXXXX'))
        OR (V_TNRNOTAFISC              = 'T'))
     INNER JOIN FORNECEDOR FO
        ON FO.CDFORNECED                 = BP.CDFORNECED
       AND ((FO.NRINSJURFORN            = V_CDFORNECED)
        OR ((SUBSTR(FO.NRINSJURFORN,1,8) = SUBSTR(V_CDFORNECED,1,8))
       AND (FO.CDGRUPFORN              IS NOT NULL))
        OR (V_TCDFORNECED                = 'T'))
     INNER JOIN EMPRESA EM
        ON EM.CDEMPRESA     = BP.CDEMPRESA
       AND EM.NRINSJUREMPR = V_NRINSJUREMPR
     INNER JOIN FILIAL FI
        ON FI.CDFILIAL         = NF.CDFILIRECE
     WHERE ((BP.DTVENBOLPAG = V_DTVENBOLPAG)
        OR ((BP.DTVENBOLPAG BETWEEN TO_DATE(V_DTVENBOLPAG)-180 AND TO_DATE(V_DTVENBOLPAG)+180)
       AND (V_TDTVENBOLPAG   = 'T')))
       AND ((BP.IDSTATBPAG   = V_IDSTATUSA
        OR BP.IDSTATBPAG      = V_IDSTATUSB
        OR BP.IDSTATBPAG      = V_IDSTATUSC)
        OR (V_IDSTATUSA       = 'T'))
       AND (((BP.VRFINALBPAG = V_VRFINALBPAG
        OR (V_TODOSVR         = 'T'))
       AND (V_IDCONSISTEVLR  = 'S'))
        OR ((BP.VRFINALBPAG BETWEEN (V_VRFINALBPAG-0.1) AND (V_VRFINALBPAG+0.1))
        OR (V_TODOSVR        = 'T'))
       AND (V_IDCONSISTEVLR = 'N'));
BEGIN
  -- Parâmetro Consiste Valor
  BEGIN
     SELECT PD.IDCONSISTE
       INTO V_IDCONSISTEVLR
       FROM PARAMDDA PD
      WHERE PD.NRSEQPARAM = '5';
  EXCEPTION
       WHEN NO_DATA_FOUND THEN
           V_IDCONSISTEVLR :=  'N';
  END;
  -- Cursor dos Retornos do DDA - Status ERRO
  FOR C_DDA IN (SELECT RD.CDFORNECED,
                       RD.NMFORNECED ,
                       RD.DTVENBOLPAG,
                       RD.NRNOTAFISC,
                       RD.VRFINALBPAG,
                       RD.DSINCONS,
                       RD.NRORG ,
                       RD.DSEMPRESA ,
                       RD.CDBANCO,
                       RD.CDEMPRESA ,
                       RD.STATUS ,
                       RD.CDBARRA,
                       RD.CNPJFILIAL,
                       RD.CDREDUCONT
                  FROM RETORNODDA RD
                 WHERE RD.STATUS = 'ERRO')LOOP
       V_ERRO         := FALSE;
       V_TITULO       := FALSE;
       V_NRNOTAFISC   := C_DDA.NRNOTAFISC;
       V_TNRNOTAFISC  := 'N';
       V_CDFORNECED   := C_DDA.CDFORNECED;
       V_TCDFORNECED  := 'N';
       V_NRINSJUREMPR := C_DDA.DSEMPRESA;
       V_DTVENBOLPAG  := C_DDA.DTVENBOLPAG;
       V_TDTVENBOLPAG := 'N';
       V_IDSTATUSA    := 'A';
       V_IDSTATUSB    := 'A';
       V_IDSTATUSC    := 'A';
       V_VRFINALBPAG  := C_DDA.VRFINALBPAG;
       V_TODOSVR      := 'N';
    BEGIN
      SELECT E.CDREDUCONT, E.CDTPBAIXAPAG
        INTO V_CDREDUCONT, V_CDTPBAIXAPAG
        FROM EMPRBANC E, BANCO B
       WHERE E.CDEMPRESA   = C_DDA.CDEMPRESA
         AND B.CDBANCCNAB  = C_DDA.CDBANCO
         AND B.CDBANCO     = E.CDBANCO
         AND B.NRORG       = E.NRORG;
    EXCEPTION WHEN NO_DATA_FOUND THEN
        V_CDREDUCONT    := NULL;
        V_CDTPBAIXAPAG  := NULL;

    END;
    -- Busca título com todos os dados do arquivo DDA - EM ABERTO
    OPEN C_DADOS_DDA(V_NRNOTAFISC, V_TNRNOTAFISC, V_CDFORNECED, V_TCDFORNECED, V_NRINSJUREMPR, V_DTVENBOLPAG, V_TDTVENBOLPAG, V_IDSTATUSA, V_IDSTATUSB, V_IDSTATUSC, V_VRFINALBPAG, V_TODOSVR );
    FETCH C_DADOS_DDA
     INTO V_REC_CDFILIAL,
          V_REC_NRLANBOLPAG,
          V_REC_CDBARRAPAG,
          V_REC_COUNT_TITULOS;
    -- Verifica existencia do Título
    IF C_DADOS_DDA%NOTFOUND THEN
       CLOSE C_DADOS_DDA;
       V_REC_CDFILIAL      := NULL;
       V_REC_NRLANBOLPAG   := NULL;
       V_REC_CDBARRAPAG    := NULL;
       V_REC_COUNT_TITULOS := NULL;
       V_IDSTATUSA         := 'P';
       V_IDSTATUSB         := 'B';
       V_IDSTATUSC         := 'C';
       -- Busca título com todos os dados do arquivo DDA - PLANEJADO/BAIXADO/CANCELADO
       OPEN C_DADOS_DDA( V_NRNOTAFISC, V_TNRNOTAFISC, V_CDFORNECED, V_TCDFORNECED, V_NRINSJUREMPR, V_DTVENBOLPAG, V_TDTVENBOLPAG, V_IDSTATUSA, V_IDSTATUSB, V_IDSTATUSC, V_VRFINALBPAG, V_TODOSVR );
       FETCH C_DADOS_DDA
        INTO V_REC_CDFILIAL,
             V_REC_NRLANBOLPAG,
             V_REC_CDBARRAPAG,
             V_REC_COUNT_TITULOS;
      -- Verifica Divergencia Status
      IF C_DADOS_DDA%NOTFOUND THEN
         CLOSE C_DADOS_DDA;
         V_REC_CDFILIAL      := NULL;
         V_REC_NRLANBOLPAG   := NULL;
         V_REC_CDBARRAPAG    := NULL;
         V_REC_COUNT_TITULOS := NULL;
         V_IDSTATUSA         := 'T';
         V_IDSTATUSB         := 'T';
         V_IDSTATUSC         := 'T';
         -- Parâmetro Consiste Fornecedor
         BEGIN
            SELECT PD.IDCONSISTE
              INTO V_IDCONSISTE
              FROM PARAMDDA PD
             WHERE PD.NRSEQPARAM = '7';
         EXCEPTION
              WHEN NO_DATA_FOUND THEN
              V_IDCONSISTE := 'N';
         END;
        IF V_IDCONSISTE     = 'S' THEN
           V_CDFORNECED     := NULL;
           V_TCDFORNECED    := 'T';
           V_NRNOTAFISC     := C_DDA.NRNOTAFISC;
           V_TNRNOTAFISC    := 'N';
           V_VRFINALBPAG    := C_DDA.VRFINALBPAG;
           V_TODOSVR        := 'N';
           V_DTVENBOLPAG    := C_DDA.DTVENBOLPAG;
           V_TDTVENBOLPAG   := 'N';
           -- Verifica Divergencia Fornecedor
           OPEN C_DADOS_DDA( V_NRNOTAFISC, V_TNRNOTAFISC, V_CDFORNECED, V_TCDFORNECED, V_NRINSJUREMPR, V_DTVENBOLPAG, V_TDTVENBOLPAG, V_IDSTATUSA, V_IDSTATUSB, V_IDSTATUSC, V_VRFINALBPAG, V_TODOSVR );
           FETCH C_DADOS_DDA
            INTO V_REC_CDFILIAL,
                 V_REC_NRLANBOLPAG,
                 V_REC_CDBARRAPAG,
                 V_REC_COUNT_TITULOS;
          IF V_REC_COUNT_TITULOS > 0 THEN
             -- Gera Inconsistência - Fornecedor inconsistente
             UPDATE RETORNODDA
                SET DSINCONS    = 'Fornecedor inconsistente.'
              WHERE CDEMPRESA = C_DDA.CDEMPRESA
                AND CDFORNECED  = C_DDA.CDFORNECED
                AND NRNOTAFISC  = C_DDA.NRNOTAFISC
                AND VRFINALBPAG = C_DDA.VRFINALBPAG;
             V_ERRO         := TRUE;
          END IF;
          CLOSE C_DADOS_DDA;
          V_REC_CDFILIAL      := NULL;
          V_REC_NRLANBOLPAG   := NULL;
          V_REC_CDBARRAPAG    := NULL;
          V_REC_COUNT_TITULOS := NULL;
        END IF;
        BEGIN
            -- Parâmetro Consiste Documento
            SELECT PD.IDCONSISTE
              INTO V_IDCONSISTE
              FROM PARAMDDA PD
             WHERE PD.NRSEQPARAM = '8';
         EXCEPTION WHEN NO_DATA_FOUND THEN
            V_IDCONSISTE := 'N';
         END;
        -- Verifica Divergencia Documento
        IF V_ERRO         = FALSE AND V_IDCONSISTE = 'S' THEN
           V_CDFORNECED   := C_DDA.CDFORNECED;
           V_TCDFORNECED  := 'N';
           V_NRNOTAFISC   := NULL;
           V_TNRNOTAFISC  := 'T';
           V_VRFINALBPAG  := C_DDA.VRFINALBPAG;
           V_TODOSVR      := 'N';
           V_DTVENBOLPAG  := C_DDA.DTVENBOLPAG;
           V_TDTVENBOLPAG := 'N';
           -- Verifica Divergencia Documento
           OPEN C_DADOS_DDA( V_NRNOTAFISC, V_TNRNOTAFISC, V_CDFORNECED, V_TCDFORNECED, V_NRINSJUREMPR, V_DTVENBOLPAG, V_TDTVENBOLPAG, V_IDSTATUSA, V_IDSTATUSB, V_IDSTATUSC, V_VRFINALBPAG, V_TODOSVR );
           FETCH C_DADOS_DDA
           INTO V_REC_CDFILIAL,
                V_REC_NRLANBOLPAG,
                V_REC_CDBARRAPAG,
                V_REC_COUNT_TITULOS;
           IF V_REC_COUNT_TITULOS > 0 THEN
             -- Gera Inconsistência - Documento inconsistente
             UPDATE RETORNODDA
                SET DSINCONS    = 'Documento inconsistente.'
              WHERE CDEMPRESA = C_DDA.CDEMPRESA
                AND CDFORNECED  = C_DDA.CDFORNECED
                AND NRNOTAFISC  = C_DDA.NRNOTAFISC
                AND VRFINALBPAG = C_DDA.VRFINALBPAG;
             V_ERRO         := TRUE;
           END IF;
           CLOSE C_DADOS_DDA;
           V_REC_CDFILIAL      := NULL;
           V_REC_NRLANBOLPAG   := NULL;
           V_REC_CDBARRAPAG    := NULL;
           V_REC_COUNT_TITULOS := NULL;
        END IF;

        -- Parâmetro Consiste Valor
        BEGIN
            SELECT PD.IDCONSISTE
              INTO V_IDCONSISTE
              FROM PARAMDDA PD
             WHERE PD.NRSEQPARAM = '5';
         EXCEPTION WHEN NO_DATA_FOUND THEN
            V_IDCONSISTE := 'N';
         END;
        -- Verifica Divergencia Valor
        IF V_ERRO = FALSE AND V_IDCONSISTE = 'S' THEN
           V_CDFORNECED   := C_DDA.CDFORNECED;
           V_TCDFORNECED  := 'N';
           V_NRNOTAFISC   := C_DDA.NRNOTAFISC;
           V_TNRNOTAFISC  := 'N';
           V_VRFINALBPAG  := 0;
           V_TODOSVR      := 'T';
           V_DTVENBOLPAG  := C_DDA.DTVENBOLPAG;
           V_TDTVENBOLPAG := 'N';
           -- Verifica Divergencia Valor
           OPEN C_DADOS_DDA( V_NRNOTAFISC, V_TNRNOTAFISC, V_CDFORNECED, V_TCDFORNECED, V_NRINSJUREMPR, V_DTVENBOLPAG, V_TDTVENBOLPAG, V_IDSTATUSA, V_IDSTATUSB, V_IDSTATUSC, V_VRFINALBPAG, V_TODOSVR );
           FETCH C_DADOS_DDA
           INTO V_REC_CDFILIAL,
                V_REC_NRLANBOLPAG,
                V_REC_CDBARRAPAG,
                V_REC_COUNT_TITULOS;
           IF V_REC_COUNT_TITULOS > 0 THEN
             -- Gera Inconsistência - Valor inconsistente
             UPDATE RETORNODDA
                SET DSINCONS    = 'Valor inconsistente.'
              WHERE CDEMPRESA = C_DDA.CDEMPRESA
                AND CDFORNECED  = C_DDA.CDFORNECED
                AND NRNOTAFISC  = C_DDA.NRNOTAFISC
                AND VRFINALBPAG = C_DDA.VRFINALBPAG;
             V_ERRO         := TRUE;
           END IF;
           CLOSE C_DADOS_DDA;
           V_REC_CDFILIAL      := NULL;
           V_REC_NRLANBOLPAG   := NULL;
           V_REC_CDBARRAPAG    := NULL;
           V_REC_COUNT_TITULOS := NULL;
        END IF;
        -- Parâmetro Consiste Data
        BEGIN
           SELECT PD.IDCONSISTE
             INTO V_IDCONSISTE
             FROM PARAMDDA PD
            WHERE PD.NRSEQPARAM = '6';
        EXCEPTION WHEN NO_DATA_FOUND THEN
            V_IDCONSISTE := 'N';
        END;
        -- Verifica Divergencia Data
        IF V_ERRO = FALSE AND V_IDCONSISTE = 'S' THEN
           V_CDFORNECED   := C_DDA.CDFORNECED;
           V_TCDFORNECED  := 'N';
           V_NRNOTAFISC   := C_DDA.NRNOTAFISC;
           V_TNRNOTAFISC  := 'N';
           V_VRFINALBPAG  := C_DDA.VRFINALBPAG;
           V_TODOSVR      := 'N';
           V_DTVENBOLPAG  := C_DDA.DTVENBOLPAG;
           V_TDTVENBOLPAG := 'T';
          -- Verifica Divergencia Data
           OPEN C_DADOS_DDA( V_NRNOTAFISC, V_TNRNOTAFISC, V_CDFORNECED, V_TCDFORNECED, V_NRINSJUREMPR, V_DTVENBOLPAG, V_TDTVENBOLPAG, V_IDSTATUSA, V_IDSTATUSB, V_IDSTATUSC, V_VRFINALBPAG, V_TODOSVR );
          FETCH C_DADOS_DDA
           INTO V_REC_CDFILIAL,
                V_REC_NRLANBOLPAG,
                V_REC_CDBARRAPAG,
                V_REC_COUNT_TITULOS;
          IF V_REC_COUNT_TITULOS > 0 THEN
             -- Gera Inconsistência - Data de vencimento inconsistente
             UPDATE RETORNODDA
                SET DSINCONS    = 'Data de vencimento inconsistente.'
              WHERE CDEMPRESA = C_DDA.CDEMPRESA
                AND CDFORNECED  = C_DDA.CDFORNECED
                AND NRNOTAFISC  = C_DDA.NRNOTAFISC
                AND VRFINALBPAG = C_DDA.VRFINALBPAG;
             V_ERRO         := TRUE;
          END IF;
          CLOSE C_DADOS_DDA;
          V_REC_CDFILIAL      := NULL;
          V_REC_NRLANBOLPAG   := NULL;
          V_REC_CDBARRAPAG    := NULL;
          V_REC_COUNT_TITULOS := NULL;
        END IF;
      ELSE
        V_TITULO := TRUE;
        CLOSE C_DADOS_DDA;
        V_REC_CDFILIAL      := NULL;
        V_REC_NRLANBOLPAG   := NULL;
        V_REC_CDBARRAPAG    := NULL;
        V_REC_COUNT_TITULOS := NULL;
        -- Gera Inconsistência - Status Inválido
        UPDATE RETORNODDA
           SET DSINCONS    = 'Título encontra-se baixado, planejado ou cancelado.'
         WHERE CDEMPRESA   = C_DDA.CDEMPRESA
           AND CDFORNECED  = C_DDA.CDFORNECED
           AND NRNOTAFISC  = C_DDA.NRNOTAFISC
           AND VRFINALBPAG = C_DDA.VRFINALBPAG;
      END IF;
    ELSE
      V_TITULO := TRUE;
      -- Verifica Quantidade de Titulos Relacionados
      IF V_REC_COUNT_TITULOS = 1 THEN
        IF V_REC_CDBARRAPAG IS NULL THEN
          -- Gera Retorno DDA - OK
          UPDATE RETORNODDA
             SET DSINCONS    = '',
                 STATUS      = 'OK'
           WHERE CDEMPRESA   = C_DDA.CDEMPRESA
             AND CDFORNECED  = C_DDA.CDFORNECED
             AND NRNOTAFISC  = C_DDA.NRNOTAFISC
             AND VRFINALBPAG = C_DDA.VRFINALBPAG;
          -- Atualiza Título DDA - OK
          UPDATE BOLETPAGAR
             SET CDREDUCONT    = NVL(V_CDREDUCONT,CDREDUCONT),
                 CDTPBAIXAPAG  = NVL(V_CDTPBAIXAPAG,CDTPBAIXAPAG),
                 CDBARRAPAG    = C_DDA.CDBARRA
           WHERE CDFILIAL      = V_REC_CDFILIAL
             AND NRLANBOLPAG   = V_REC_NRLANBOLPAG;
        ELSE
          -- Gera Inconsistência - Código de Barras Preenchido
          UPDATE RETORNODDA
             SET DSINCONS    = 'Título já possui código de barras preenchido.'
           WHERE CDEMPRESA   = C_DDA.CDEMPRESA
             AND CDFORNECED  = C_DDA.CDFORNECED
             AND NRNOTAFISC  = C_DDA.NRNOTAFISC
             AND VRFINALBPAG = C_DDA.VRFINALBPAG;
        END IF;
      ELSE
        -- Gera Inconsistência - Títulos Relacionados
        UPDATE RETORNODDA
           SET DSINCONS    = 'Existem mais de um título relacionado a Empresa, Data de Vencimento, Fornecedor e Valor.'
         WHERE CDEMPRESA   = C_DDA.CDEMPRESA
           AND CDFORNECED  = C_DDA.CDFORNECED
           AND NRNOTAFISC  = C_DDA.NRNOTAFISC
           AND VRFINALBPAG = C_DDA.VRFINALBPAG;
      END IF;
      CLOSE C_DADOS_DDA;
      V_REC_CDFILIAL      := NULL;
      V_REC_NRLANBOLPAG   := NULL;
      V_REC_CDBARRAPAG    := NULL;
      V_REC_COUNT_TITULOS := NULL;
    END IF;
    IF V_TITULO = FALSE AND V_ERRO = FALSE THEN
       V_CDFORNECED   := C_DDA.CDFORNECED;
       V_TCDFORNECED  := 'N';
       V_NRNOTAFISC   := NULL;
       V_TNRNOTAFISC  := 'T';
       V_VRFINALBPAG  := C_DDA.VRFINALBPAG;
       V_TODOSVR      := 'N';
       V_DTVENBOLPAG  := C_DDA.DTVENBOLPAG;
       V_TDTVENBOLPAG := 'N';
       V_IDSTATUSA    := 'A';
       V_IDSTATUSB    := 'A';
       V_IDSTATUSC    := 'A';
      -- Busca título com todos os dados do arquivo DDA - EM ABERTO - SEM DOCUMENTO
      OPEN C_DADOS_DDA( V_NRNOTAFISC, V_TNRNOTAFISC, V_CDFORNECED, V_TCDFORNECED, V_NRINSJUREMPR, V_DTVENBOLPAG, V_TDTVENBOLPAG, V_IDSTATUSA, V_IDSTATUSB, V_IDSTATUSC, V_VRFINALBPAG, V_TODOSVR );
      FETCH C_DADOS_DDA
       INTO V_REC_CDFILIAL,
            V_REC_NRLANBOLPAG,
            V_REC_CDBARRAPAG,
            V_REC_COUNT_TITULOS;
      -- Verifica existencia do Título
      IF C_DADOS_DDA%NOTFOUND THEN
         CLOSE C_DADOS_DDA;
         V_REC_CDFILIAL      := NULL;
         V_REC_NRLANBOLPAG   := NULL;
         V_REC_CDBARRAPAG    := NULL;
         V_REC_COUNT_TITULOS := NULL;
         V_CDFORNECED        := C_DDA.CDFORNECED;
         V_TCDFORNECED       := 'N';
         V_NRNOTAFISC        := NULL;
         V_TNRNOTAFISC       := 'T';
         V_VRFINALBPAG       := C_DDA.VRFINALBPAG;
         V_TODOSVR           := 'N';
         V_DTVENBOLPAG       := C_DDA.DTVENBOLPAG;
         V_TDTVENBOLPAG      := 'N';
         V_IDSTATUSA         := 'P';
         V_IDSTATUSB         := 'B';
         V_IDSTATUSC         := 'C';
        -- Busca título com todos os dados do arquivo DDA - PLANEJADO/BAIXADO/CANCELADO
        OPEN C_DADOS_DDA( V_NRNOTAFISC, V_TNRNOTAFISC, V_CDFORNECED, V_TCDFORNECED, V_NRINSJUREMPR, V_DTVENBOLPAG, V_TDTVENBOLPAG, V_IDSTATUSA, V_IDSTATUSB, V_IDSTATUSC, V_VRFINALBPAG, V_TODOSVR );
        FETCH C_DADOS_DDA
         INTO V_REC_CDFILIAL,
              V_REC_NRLANBOLPAG,
              V_REC_CDBARRAPAG,
              V_REC_COUNT_TITULOS;
        IF C_DADOS_DDA%NOTFOUND THEN
          -- Gera Inconsistência - Não foi encontrado nenhum título no sistema correspondente ao do arquivo DDA.
          UPDATE RETORNODDA
             SET DSINCONS    = 'Não foi encontrado nenhum título no sistema correspondente ao do arquivo DDA.'
           WHERE CDEMPRESA = C_DDA.CDEMPRESA
             AND CDFORNECED  = C_DDA.CDFORNECED
             AND NRNOTAFISC  = C_DDA.NRNOTAFISC
             AND VRFINALBPAG = C_DDA.VRFINALBPAG;
        ELSE
          -- Gera Inconsistência - Título encontra-se baixado, planejado ou cancelado.
          UPDATE RETORNODDA
             SET DSINCONS    = 'Título encontra-se baixado, planejado ou cancelado.'
           WHERE CDEMPRESA   = C_DDA.CDEMPRESA
             AND CDFORNECED  = C_DDA.CDFORNECED
             AND NRNOTAFISC  = C_DDA.NRNOTAFISC
             AND VRFINALBPAG = C_DDA.VRFINALBPAG;
        END IF;
        CLOSE C_DADOS_DDA;
        V_REC_CDFILIAL      := NULL;
        V_REC_NRLANBOLPAG   := NULL;
        V_REC_CDBARRAPAG    := NULL;
        V_REC_COUNT_TITULOS := NULL;
      ELSE
        -- Verifica Quantidade de Titulos Relacionados
        IF V_REC_COUNT_TITULOS = 1 THEN
          IF V_REC_CDBARRAPAG IS NULL THEN
            -- Gera Retorno DDA - OK
            UPDATE RETORNODDA
               SET DSINCONS  = '',
                   STATUS    = 'OK'
             WHERE CDEMPRESA = C_DDA.CDEMPRESA
               AND CDFORNECED  = C_DDA.CDFORNECED
               AND NRNOTAFISC  = C_DDA.NRNOTAFISC
               AND VRFINALBPAG = C_DDA.VRFINALBPAG;
            -- Atualiza Título DDA - OK
            UPDATE BOLETPAGAR
               SET CDREDUCONT    = V_CDREDUCONT,
                   CDTPBAIXAPAG  = V_CDTPBAIXAPAG,
                   CDBARRAPAG    = C_DDA.CDBARRA
             WHERE CDFILIAL      = V_REC_CDFILIAL
               AND NRLANBOLPAG = V_REC_NRLANBOLPAG;
          ELSE
            -- Gera Inconsistência - Código de Barras Preenchido
            UPDATE RETORNODDA
               SET DSINCONS    = 'Título já possui código de barras preenchido.'
             WHERE CDEMPRESA   = C_DDA.CDEMPRESA
               AND CDFORNECED  = C_DDA.CDFORNECED
               AND NRNOTAFISC  = C_DDA.NRNOTAFISC
               AND VRFINALBPAG = C_DDA.VRFINALBPAG;
          END IF;
        ELSE
          -- Gera Inconsistência - Títulos Relacionados
          UPDATE RETORNODDA
             SET DSINCONS    = 'Existem mais de um título relacionado a Empresa, Data de Vencimento, Fornecedor e Valor.'
           WHERE CDEMPRESA   = C_DDA.CDEMPRESA
             AND CDFORNECED  = C_DDA.CDFORNECED
             AND NRNOTAFISC  = C_DDA.NRNOTAFISC
             AND VRFINALBPAG = C_DDA.VRFINALBPAG;
        END IF;
        CLOSE C_DADOS_DDA;
        V_REC_CDFILIAL      := NULL;
        V_REC_NRLANBOLPAG   := NULL;
        V_REC_CDBARRAPAG    := NULL;
        V_REC_COUNT_TITULOS := NULL;
      END IF;
    END IF;
  END LOOP;
  COMMIT;
END;